// pserv2Doc.h : interface of the CPserv2Doc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PSERV2DOC_H__143F6D6A_1D24_4B95_8594_1D16552F82F5__INCLUDED_)
#define AFX_PSERV2DOC_H__143F6D6A_1D24_4B95_8594_1D16552F82F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CService.h"
#include "CEventLog.h"
#include "CProcessList.h"
#include "CModulesList.h"

typedef enum 
{
    DocType_Services, 
    DocType_Events,
    DocType_ProcessList,
    DocType_ModulesList
} DocType;

class CPserv2Doc : public CDocument
{
protected: // create from serialization only
	CPserv2Doc();
	DECLARE_DYNCREATE(CPserv2Doc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPserv2Doc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPserv2Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
    
    CListViewEntries* m_pEntries;

    // should be removed one day ;)
    DocType m_DocType;

protected:
    CObList m_Providers;
    CServiceList m_ServiceList;
    CEventLog m_EventLog;
    CProcessList m_ProcessList;
    CModuleList m_ModulesList;

    void DoConfigExchange(BOOL bSave);

    void IGetExportFilename(LPCTSTR lpszDefExt, CString& refFilename, LPCTSTR lpszFilter, BOOL& success, BOOL bOpenFileDialog = FALSE);
    BOOL GetExportFilename(LPCTSTR lpszDefExt, CString& refFilename, LPCTSTR lpszFilter, BOOL bOpenFileDialog);

// Generated message map functions
protected:
	//{{AFX_MSG(CPserv2Doc)
	afx_msg void OnDisplayExportAsXml();
	afx_msg void OnViewServices();
	afx_msg void OnViewDevices();
	afx_msg void OnViewSystemEvents();
	afx_msg void OnViewSecurityEvents();
    afx_msg void OnViewProcessList();
    afx_msg void OnViewModulesList();
	afx_msg void OnViewApplicationEvents();
	afx_msg void OnDisplayExportToClipboard();
	afx_msg void OnTemplatesApply();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PSERV2DOC_H__143F6D6A_1D24_4B95_8594_1D16552F82F5__INCLUDED_)
